#include <iostream>
#include <vector>

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

using namespace std;

 struct Input {
        vector<double> numbers;
        size_t bin_count{};
    };

Input
input_data(){

    size_t number_count;
    cerr << "Enter number_count: ";
    cin >> number_count;

    Input in;
    in.numbers.resize(number_count);
    cerr << "Enter numbers: ";
    for (size_t i = 0; i < number_count; i++){
        cin >> in.numbers[i];
    }

    cerr << "Enter bin count: ";
    cin >> in.bin_count;

    return in;
}

void
find_minmax(vector<double>& numbers, double& min, double& max){
    min = numbers[0];
    max = numbers[0];

    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
}


vector<size_t> make_histogram(vector<double>& numbers, size_t bin_count){

    vector<size_t> bins(bin_count);

    double min, max;
    find_minmax(numbers, min, max);

    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < numbers.size(); i++) {
        bool found = false; //    .     
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) { //  j- 
            auto lo = min + j * bin_size; //    
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) { //     i-   numbers
                bins[j]++; //       (),    j- 
                found = true; //  "",        . .  numbers
            }                 //             
        }
        if (!found) { //      .  ,   ,      
            bins[bin_count - 1]++; //   .   
        }
    }
    return bins;
}



int
main()
{
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);

    size_t max_count = 0;
    for (size_t x: bins) {
        if (x > max_count) {
                max_count = x;
        }
    }

    if (max_count > MAX_ASTERISK) {
        for (size_t count: bins) {
            size_t height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
            if (count < 10) {
                cout << "  " << count << "|";
            }
            else if (count >= 100) {
                cout << count << "|";
            }

            else {
                cout << " " << count << "|";
            }

            for (size_t i = 0; i < height; i++) {
                cout << "*";
            }
            cout << "\n";
        }
    }

    else {
        for (size_t x: bins) {
            if (x < 10) {
                cout << "  " << x << "|";
            }
            else if (x >= 100) {
                cout << x << "|";
            }

            else {
                cout << " " << x << "|";
            }

            for (size_t i = 0; i < x; i++) {
                cout << "*";
            }
            cout << "\n";
        }
    }

    return 0;
}
